#include "zeusmp.def"

c JCV 7/24/2006 a tilted, precessing jet.

c=======================================================================
c
c    \\\\\\\\\\      B E G I N   S U B R O U T I N E      //////////
c    //////////                 XYZ_PRECESS               \\\\\\\\\\
c
c=======================================================================
c
       subroutine xyz_precess

       implicit NONE
#include "mod_names.h"
#include "param.h"
#include "field.h"
#include "bndry.h"
#include "grid.h"
#include "root.h"
#include "scratch.h"
#include "mpicom.h"

       integer i,j,k

       integer thetamax
       REAL alphar,beta
       REAL vx,vy,vz,vr,vt,vp
       REAL offtime
       integer njet
       namelist /jet/ djet,v1jet,jetsize,efficiency,mcutoff
       namelist /prec/ palpha,pomega

       njet=3
       offtime=1.0

c This is alpha in radians
       alphar=(palpha/180.0)*pi
       if(pomega.eq.0.0)then
          beta=0.0
       else
          beta=(time/(2.0*pomega))*pi
       endif
       thetamax=J_ZONES*ntiles(2)/jetsize
c Uncomment the next line if there is only one jet
          thetamax=thetamax*2.0
c Only look for jet near inner edge
      if (x1b(is) .LE. 1) then

c NOTE if there are too many processors (~10), this will no longer work

c Do first jet if t direction starts close to 0
         do j=js-2,je+2
            do k=ks-2,ke+2
               if ((x2b(j).le.0.15).and.(x2b(j).ge.-0.15))then
                  if ((x3b(k).le.0.15).and.(x3b(k).ge.-0.15))then
                  diib(j,k,1)=djet
                  diib(j,k,2)=djet
                  eiib(j,k,1)=9.0/10.0
                  eiib(j,k,2)=9.0/10.0
                  
                  vz=v1jet*cos(alphar)
                  vy=v1jet*sin(alphar)*cos(beta)
                  vx=v1jet*sin(alphar)*sin(beta)

      if (time .GT. offtime .AND. time .LT. offtime + dt) then
         
         if(myid.eq.0)then
            write(6,"(/'Turning jet off')")
         endif
         njet=2
         vx=0.0
         vy=0.0
         vz=0.0
      endif

c vx and vz and switched in xyz
                  niib(j,k)=njet
                  v1iib(j,k,1)=vz
                  v1iib(j,k,2)=vz
                  v2iib(j,k,1)=vy
                  v2iib(j,k,2)=vy
                  v3iib(j,k,1)=vx
                  v3iib(j,k,2)=vz
                  endif
               endif
               enddo
            enddo

c end loop for 1st jet
c end loop for both jets
      endif
ccccccccccc

       return
       end
